<?php
declare (strict_types = 1);

namespace app\admin\model\v1;

use app\common\model\VideoCategoryBaseModel;
use think\model\concern\SoftDelete;

/**
 * 视频分类模型
 * @mixin \think\Model
 */
class VideoCategoryModel extends VideoCategoryBaseModel
{
    // 启用软删除
    use SoftDelete;
    // 软删除字段
    protected $deleteTime = 'deleted_at';
    
    // 关联视频模型
    public function video()
    {
        return $this->hasMany(VideoModel::class, 'category_id', 'id');
    }

    // 分类名称搜索
    public function searchNameAttr($query, $value)
    {
        if (empty($value)) {
            return;
        }
        $query->where('name', 'like', '%' . $value . '%');
    }

    // 语言查询
    public function scopeLanguage($query, $value)
    {
        $query->where('language_id', '=', $value);
    }

    // 显示状态查询
    public function scopeIsShow($query, bool $value = true)
    {
        $query->where('is_show', '=', (int)$value);
    }
}
